commit:     d2fc803ff1c8f3df2a19a6d3ee91d31de7463486
Author:     Hank Leininger <hlein <AT> korelogic <DOT> com>
AuthorDate: Sun Dec  4 19:02:59 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Mon Dec  5 04:21:00 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=d2fc803f

app-editors/vim-core: add 9.0.1000

Latest upstream fixes numerous CVEs.

Signed-off-by: Hank Leininger <hlein <AT> korelogic.com>
Bug: https://bugs.gentoo.org/883681
Signed-off-by: Sam James <sam <AT> gentoo.org>

 app-editors/vim-core/Manifest                 |   1 +
 app-editors/vim-core/vim-core-9.0.1000.ebuild | 230 ++++++++++++++++++++++++++
 2 files changed, 231 insertions(+)

diff --git a/app-editors/vim-core/Manifest b/app-editors/vim-core/Manifest
index 7ce52533f482..be91e4d6c4ee 100644
--- a/app-editors/vim-core/Manifest
+++ b/app-editors/vim-core/Manifest
@@ -2,4 +2,5 @@ DIST vim-9.0.0099.tar.gz 16712565 BLAKE2B 
b3277ebda0bb40601d995935422006d1a266bb
 DIST vim-9.0.0399.tar.gz 16833387 BLAKE2B 
f9d6588920b49ef32b82d012e1c4f8a34dc505267b67027a3b4302dd99d7987645c29a91fdb234fffa873b342488b4d9c85d05d3fe7a332042781881a61bea5e
 SHA512 
6b261bf3aaa355e7a42de1785b134bccc51086495578730b9bc3b8e048679caa3a901e576a360cba5f1aa4d164c7f162a3f916e945b3f5f71e893ea30e0ca826
 DIST vim-9.0.0655.tar.gz 16804127 BLAKE2B 
e021ff4dd370cdd9b39fb9df0a12309215abd780ec297760b92b6caf924882465b28f9ba65d94ad75a229eb01c8f393f24a29a11919a96d78bb6fb45ef2971e3
 SHA512 
aa267941e835eecbeeffa7989fb525bdf4269f84d9c88d135a26d74ab7d025487863405b6e0f1391023c30193a122ed3e85a7a71bd4dc48058f3fe3377798f38
 DIST vim-9.0.0828.tar.gz 16782339 BLAKE2B 
6b997c1c828338d64a8b204a1e232676ec075834b1b7e74c2fc671e315f9bf6026b0c419ebb3c31e7ce58dbca23828ca11d866b2bfcb73f8a86fb31fa0d51b00
 SHA512 
03f93515039a2f275a8fe6b84bbac5875ffff17768ab3201e111eba4897a2485fe4ccfe238151f393334c7a6ea77eddd8898f0b816e26dbdb884f4e6bcbd2943
+DIST vim-9.0.1000.tar.gz 16842747 BLAKE2B 
85edab7d13daa3e84ef0aeb50e3e9bfd31f0634d8e480c105727b0c34318e0adf7f1276dcdac53df8fc416fd8dfb70377cd74ed570752a3e77f07a083fa6c113
 SHA512 
9d2b914a112948d77b92c8dcafc2f711a83c3fdaf35a28f7f606e77007b9320e2260a0f6b24fc875a817c33c012f077f89730b34e9f12d6f00795c5c806704c8
 DIST vim-patches-vim-9.0.0049-patches.tar.gz 2743 BLAKE2B 
dff3e215b235e1cbc2c62b1af2d1414d10b794dbee9f5e7797fb3d34e00c2e065c339d4c82bf28aed53e0b5f2f8f1ee5c7ce69851cd63360788609bf144ac922
 SHA512 
7d5c64d674fa77048fdca7287072c0e488723133e254c10711dbadf750416c368725327ca9b76f332017bc70aa544a9baef671765eabf0d172d39921ffd7d942

diff --git a/app-editors/vim-core/vim-core-9.0.1000.ebuild 
b/app-editors/vim-core/vim-core-9.0.1000.ebuild
new file mode 100644
index 000000000000..9412ba51653d
--- /dev/null
+++ b/app-editors/vim-core/vim-core-9.0.1000.ebuild
@@ -0,0 +1,230 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+# Please bump with app-editors/vim and app-editors/gvim
+
+VIM_VERSION="9.0"
+inherit bash-completion-r1 desktop flag-o-matic prefix toolchain-funcs vim-doc 
xdg-utils
+
+if [[ ${PV} == 9999* ]] ; then
+       inherit git-r3
+       EGIT_REPO_URI="https://github.com/vim/vim.git";
+       EGIT_CHECKOUT_DIR=${WORKDIR}/vim-${PV}
+else
+       SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> 
vim-${PV}.tar.gz
+               
https://gitweb.gentoo.org/proj/vim-patches.git/snapshot/vim-patches-vim-9.0.0049-patches.tar.gz";
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~m68k ~mips ~ppc 
~ppc64 ~riscv ~s390 ~sparc ~x86 ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos 
~x64-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+fi
+S="${WORKDIR}/vim-${PV}"
+
+DESCRIPTION="vim and gvim shared files"
+HOMEPAGE="https://vim.sourceforge.io/ https://github.com/vim/vim";
+
+LICENSE="vim"
+SLOT="0"
+IUSE="nls acl minimal"
+
+# ncurses is only needed by ./configure, so no subslot operator required
+DEPEND=">=sys-libs/ncurses-5.2-r2:0"
+BDEPEND="sys-devel/autoconf"
+
+pkg_setup() {
+       # people with broken alphabets run into trouble. bug #82186.
+       unset LANG LC_ALL
+       export LC_COLLATE="C"
+}
+
+src_prepare() {
+       if [[ ${PV} != 9999* ]] ; then
+               # Gentoo patches to fix runtime issues, cross-compile errors, 
etc
+               eapply "${WORKDIR}"/vim-patches-vim-9.0.0049-patches
+       fi
+
+       # Fixup a script to use awk instead of nawk
+       sed -i \
+               -e '1s|.*|#!'"${EPREFIX}"'/usr/bin/awk -f|' \
+               "${S}"/runtime/tools/mve.awk || die "sed failed"
+
+       # See bug #77841. We remove this file after the tarball extraction.
+       rm -v "${S}"/runtime/tools/vimspell.sh || die "rm failed"
+
+       # Read vimrc and gvimrc from /etc/vim
+       echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' >> 
"${S}"/src/feature.h || die
+       echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' >> 
"${S}"/src/feature.h || die
+
+       # Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
+       # Hopefully this pattern won't break for a while at least.
+       # This fixes bug #29398 (27 Sep 2003 agriffis)
+       sed -i 's/\<ctags\("\| [-*.]\)/exuberant-&/g' \
+               "${S}"/runtime/doc/syntax.txt \
+               "${S}"/runtime/doc/tagsrch.txt \
+               "${S}"/runtime/doc/usr_29.txt \
+               "${S}"/runtime/menu.vim \
+               "${S}"/src/configure.ac || die 'sed failed'
+
+       # Don't be fooled by /usr/include/libc.h.  When found, vim thinks
+       # this is NeXT, but it's actually just a file in dev-libs/9libs
+       # This fixes bug #43885 (20 Mar 2004 agriffis)
+       sed -i 's/ libc\.h / /' "${S}"/src/configure.ac || die 'sed failed'
+
+       # gcc on sparc32 has this, uhm, interesting problem with detecting EOF
+       # correctly. To avoid some really entertaining error messages about 
stuff
+       # which isn't even in the source file being invalid, we'll do some 
trickery
+       # to make the error never occur. bug 66162 (02 October 2004 ciaranm)
+       find "${S}" -name '*.c' | while read c; do
+               echo >> "$c" || die "echo failed"
+       done
+
+       # Try to avoid sandbox problems. Bug #114475.
+       if [[ -d "${S}"/src/po ]]; then
+               sed -i -e \
+                       '/-S check.vim/s,..VIM.,ln -s $(VIM) testvim \; 
./testvim -X,' \
+                       "${S}"/src/po/Makefile || die "sed failed"
+       fi
+
+       cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp 
failed"
+
+       # Bug #378107 - Build properly with >=perl-core/ExtUtils-ParseXS-3.20.0
+       sed -i -e \
+               "s:\\\$(PERLLIB)/ExtUtils/xsubpp:${EPREFIX}/usr/bin/xsubpp:" \
+               "${S}"/src/Makefile || die 'sed for ExtUtils-ParseXS failed'
+
+       # Fix bug #76331: -O3 causes problems, use -O2 instead. We'll do this 
for
+       # everyone since previous flag filtering bugs have turned out to affect
+       # multiple archs...
+       replace-flags -O3 -O2
+
+       # Fix bug #18245: Prevent "make" from the following chain:
+       # (1) Notice configure.ac is newer than auto/configure
+       # (2) Rebuild auto/configure
+       # (3) Notice auto/configure is newer than auto/config.mk
+       # (4) Run ./configure (with wrong args) to remake auto/config.mk
+       sed -i 's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed 
failed"
+
+       # Remove src/auto/configure file.
+       rm -v src/auto/configure || die "rm configure failed"
+
+       eapply_user
+}
+
+src_configure() {
+       # Fix bug #37354: Disallow -funroll-all-loops on amd64
+       # Bug 57859 suggests that we want to do this for all archs
+       filter-flags -funroll-all-loops
+
+       emake -j1 -C src autoconf
+
+       # This should fix a sandbox violation (see bug 24447). The hvc
+       # things are for ppc64, see bug 86433.
+       for file in /dev/pty/s* /dev/console /dev/hvc/* /dev/hvc*; do
+               if [[ -e "${file}" ]]; then
+                       addwrite ${file}
+               fi
+       done
+
+       # Let Portage do the stripping. Some people like that.
+       export ac_cv_prog_STRIP="$(type -P true ) faking strip"
+
+       local myconf=(
+               --with-modified-by=Gentoo-${PVR}
+               --enable-gui=no
+               --without-x
+               --disable-darwin
+               --disable-perlinterp
+               --disable-pythoninterp
+               --disable-rubyinterp
+               --disable-gpm
+               --disable-selinux
+               $(use_enable nls)
+               $(use_enable acl)
+       )
+
+       # Keep Gentoo Prefix env contained within the EPREFIX
+       use prefix && myconf+=( --without-local-dir )
+
+       if tc-is-cross-compiler ; then
+               export vim_cv_getcwd_broken=no \
+                          vim_cv_memmove_handles_overlap=yes \
+                          vim_cv_stat_ignores_slash=yes \
+                          vim_cv_terminfo=yes \
+                          vim_cv_toupper_broken=no
+       fi
+
+       econf "${myconf[@]}"
+}
+
+src_compile() {
+       emake -j1 -C src auto/osdef.h objects
+       emake tools
+}
+
+src_test() { :; }
+
+src_install() {
+       local vimfiles=/usr/share/vim/vim${VIM_VERSION/.}
+
+       dodir /usr/{bin,share/{man/man1,vim}}
+       emake -C src \
+               installruntime \
+               installmanlinks \
+               installmacros \
+               installtutor \
+               installtutorbin \
+               installtools \
+               install-languages \
+               DESTDIR="${D}" \
+               BINDIR="${EPREFIX}"/usr/bin \
+               MANDIR="${EPREFIX}"/usr/share/man \
+               DATADIR="${EPREFIX}"/usr/share
+
+       keepdir ${vimfiles}/keymap
+
+       # default vimrc is installed by vim-core since it applies to
+       # both vim and gvim
+       insinto /etc/vim/
+       newins "${FILESDIR}"/vimrc-r6 vimrc
+       eprefixify "${ED}"/etc/vim/vimrc
+
+       if use minimal; then
+               # To save space, install only a subset of the files.
+               # Helps minimalize the livecd, bug 65144.
+               rm -rv "${ED}${vimfiles}"/{compiler,doc,ftplugin,indent} || die
+               rm -rv "${ED}${vimfiles}"/{macros,print,tools,tutor} || die
+               rm -v "${ED}"/usr/bin/vimtutor || die
+
+               for f in "${ED}${vimfiles}"/colors/*.vim; do
+                       if [[ ${f} != */@(default).vim ]] ; then
+                               printf '%s\0' "${f}"
+                       fi
+               done | xargs -0 rm -f || die
+
+               for f in "${ED}${vimfiles}"/syntax/*.vim; do
+                       if [[ ${f} != 
*/@(conf|crontab|fstab|inittab|resolv|sshdconfig|syntax|nosyntax|synload).vim 
]] ; then
+                               printf '%s\0' "${f}"
+                       fi
+               done | xargs -0 rm -f || die
+       fi
+
+       newbashcomp "${FILESDIR}"/xxd-completion xxd
+
+       # install gvim icon since both vim/gvim desktop files reference it
+       doicon -s scalable "${FILESDIR}"/gvim.svg
+}
+
+pkg_postinst() {
+       # update documentation tags (from vim-doc.eclass)
+       update_vim_helptags
+
+       # update icon cache
+       xdg_icon_cache_update
+}
+
+pkg_postrm() {
+       # Update documentation tags (from vim-doc.eclass)
+       update_vim_helptags
+
+       # update icon cache
+       xdg_icon_cache_update
+}

Reply via email to